//ColumnLines (ver. 1,  4.03.2009)
//An InDesign CS3, CS4 JavaScript
//	 Скрипт  расставляет разграничительные линии между колонками в многоколоночных фреймах.
// Особенностью скрипта является расстановка линий с учетом других объектов,
// находяшихся на полосе. Обрабатываются все фреймы выделенной Story
// Перед запуском скрипта надо самому создать объектный стиль для линий
// При разработке скрипта не ставилась задача создавать отдельный слой для линий.
//
// 	ОГРАНИЧЕНИЯ 
// Скрипт будет некорректно расставлять линии, если обтекаемые линией объекты повернуты на N градусов
// Скрипт не работает с многоколоночными фреймами, повернутыми на N градусов
// (c) Б.Кащеев  boriskasmoscow@gmail.com

main();
function main()
{

	if (app.documents.length == 0) 
	{
		alert ("Документ не открыт. Откройте вначале документ");
		return;
	}
	if(app.activeDocument.stories.length == 0) {
			alert ("В документе нет текста");
			return;
	}

	if(app.selection.length == 1){
			switch(app.selection[0].constructor.name){
				case "InsertionPoint":
				case "Character":
				case "Word":
				case "Line":
				case "TextStyleRange":
				case "Paragraph":
				case "TextColumn":
				case "Text":
				case "Cell":
				case "Column":
				case "Row":
				case "Table":
				case "TextFrame":
					var mySelectionStory = app.selection[0].parentStory;
					if( myTestTextColumn(mySelectionStory) ) {
							myDisplayDialog();
						}
					break;
				default:
				alert("Вставьте курсор в текст или выделите стрелкой текстовый фрейм");	
			}
		}
	else {
		alert("Вставьте курсор в текст или выделите один текстовый фрейм");
		return;
		}
} // main()
//=============================================================================
function myTestTextColumn(myStory) 
{
// проверяем, есть ли колонки во фреймах выделенной Story.
var j=0;
var myTextFrame;
	 for(var myCounter = 0 ; myCounter < myStory.textContainers.length; myCounter++){
            myTextFrame = myStory.textContainers[myCounter];
			if( myTextFrame.textFramePreferences.textColumnCount > 1) j++;
        }

	return j;
}
//=============================================================================
function myDisplayDialog()
{
	var myObjectStyleNames = myGetObjectStyleNames();
	var myDialog = app.dialogs.add({name:"Вертикальные линии между колонками",canCancel:true});
	with(myDialog.dialogColumns.add()){

		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"Выберите объектный стиль для линий"});
					}
				with(dialogRows.add()){
					var myObjectStyleDropdown = dropdowns.add( {stringList : myObjectStyleNames, selectedIndex : 0, minWidth : 260 });
					}
				with(dialogRows.add()){
					staticTexts.add({staticLabel:"Отступы от объектов в пунктах:"});
					with(dialogColumns.add()){						
						var myPointSizeField = realEditboxes.add({editValue:5});
							}
						}
			with(dialogRows.add()){
					with(dialogColumns.add()){
						var myOldLinesStatusControl = checkboxControls.add({staticLabel:"Удалить существующие линии", checkedState:0});
														
							}
						}		
					}//with (dialogColumns.add())
		}// with (borderPanels.add())

			
	}// with(myDialog.dialogColumns.add())
//---------- конец программирования диалогового окна ------------------------
	var myResult = myDialog.show();
		if(myResult == true){
			// Единицы  измерения - сохраняем старые, устанавливаем новые
			var myOldXUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
			var myOldYUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
			app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
			app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
			// ---------------------------------------------------------------------------------------------------------------
			var myObjectStyleNumber = myObjectStyleDropdown.selectedIndex;
			var myOldLinesStatus = myOldLinesStatusControl.checkedState;
			var myPointSize = myPointSizeField.editValue; 
			myDialog.destroy();
			//////// Удаляем линии, если это отмечено в диалоговом окне
		/*	if (myOldLinesStatus) { myRemoveOldLines(); }
			myLinesDraw(myObjectStyleNames[myObjectStyleNumber], myPointSize); */
		// всегда удаляем линии, если они есть и рисуем, если опция удаления линий не была выбрана.
		// Это позволяет обновлять стили линий.
			myRemoveOldLines(); 
			if (! myOldLinesStatus) myLinesDraw(myObjectStyleNames[myObjectStyleNumber], myPointSize);
			
			// Возвращаем старые единицы измерения
			app.activeDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
			app.activeDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;			
			
		} // if(myResult == true)
	else {	myDialog.destroy(); }
} //' function myDisplayDialog()
//=========================================================================
function myGetObjectStyleNames()
// Получаем список объектных стилей
{
	var myObjectStyleNames = app.activeDocument.objectStyles.everyItem().name;
	//var myObjectStyleNames = app.documents.item(0).objectStyles.everyItem().name;

	// Удаляем стандартные объектные стили
	for(var i =0; i<4; i++) { myObjectStyleNames.shift() }
	if(!myObjectStyleNames.length)	{
		alert("Необходимо создать объектный стиль для линий");	
		exit();
	}
	return myObjectStyleNames;
}

function myRemoveOldLines()
{
//	alert("Функция удаления старых линий");
var myCurrentPageName;
var myPage;
var myTextFrame;
var myPageItems;
var myGrLines;
var result;

	var myStory = app.selection[0].parentStory;

	// цикл по связанным фреймам story
	 for(var myCounter = 0 ; myCounter < myStory.textContainers.length; myCounter++){
            myTextFrame = myStory.textContainers[myCounter];
			if( myTextFrame.textFramePreferences.textColumnCount == 1) continue;
				myPage = myTextFrame.parent;
				myPageItems = myPage.allPageItems;
				//alert(myPageItems.length);
				myGrLines = myRemoveNoGLines(myPageItems);
				// Цикл по графическим линиям
				for (var i=0; i < myGrLines.length; i++)
					{
						result = myDeleteGrLineYesNo(myTextFrame, myGrLines[i]);
						//alert (result);
						if(result) myGrLines[i].remove();
					} // for 
        } // for по фреймам story
	
} // function myRemoveOldLines()
//==========================================================================
function myRemoveNoGLines(myPageItems)
// Получение массива с графическими линиями 
{
var myGrL = new Array();
	for (var i = 0;  i < myPageItems.length; i++)
		{
			if( myPageItems[i].constructor.name == "GraphicLine")
				{
					myGrL.push( myPageItems[i] );
				}
		}
	return myGrL;
}// function myRemoveNoGLines()
// ==============================================================================
function myDeleteGrLineYesNo(myTF, myGL)
// Функция определяет - удалять или не удалять графическую линию: возвращает 0 или 1
{
// geometricBounds – массив значений координат фрейма в формате [y1, x1, y2, x2], 
//где y1, x1 – координаты левого верхнего угла фрейма, y2 и x2 – координаты правого нижнего. 
var myTFBounds = myTF.geometricBounds;
var myGLBounds = myGL.geometricBounds;
var myColumnCount = myTF.textFramePreferences.textColumnCount;
var myGutterWidth = myTF.textFramePreferences.textColumnGutter;
var myTFColumnWidth =( (myTF.geometricBounds[3] - myTF.geometricBounds[1]) - myGutterWidth * (myColumnCount-1) ) / myColumnCount ;
var x1, x2, y1, y2;
var myDelta = 5; // это допуск на то, что линия может быть нарисована с небольшим выходом за границы фрейма
var j=0;

	y1 = myTFBounds[0]  - myDelta ;
	y2 = myTFBounds[2] + myDelta ;
	
	if (myGLBounds[0] < y1 || myGLBounds[2]  > y2) return 0; // Не удаляем

// Цикл по колонкам
	for(var i=0; i < myColumnCount-1; i++ ) {
			x1 = myTF.geometricBounds[1] + myTFColumnWidth *(1+i) +myGutterWidth * i;
			x2 = x1 + myGutterWidth;
			if ( myGLBounds[1] > x1 &&  myGLBounds[3]  < x2)  return 1;
		}

return 0;
}// End of function myDeleteGrLineYesNo()

function myLinesDraw(myObjectStyleName, myDelta)
{
var myTextFrame;
var myPage;
var myPageItems;
var myObjects;
var x1, x2, xc;
var myNewObj = new Array();

var myStory = app.selection[0].parentStory;

	for(var myCounter = 0 ; myCounter < myStory.textContainers.length; myCounter++){
            myTextFrame = myStory.textContainers[myCounter];
			if( myTextFrame.textFramePreferences.textColumnCount == 1)  {continue; } // Этот фрейм имееттолько 1 колонку
				myPage = myTextFrame.parent;
				myPageItems = myPage.allPageItems;
				// 
				var myColumnCount = myTextFrame.textFramePreferences.textColumnCount; // число колонок				
				var myGutterWidth = myTextFrame.textFramePreferences.textColumnGutter; // ширина межколонника
				var myTFColumnWidth =( (myTextFrame.geometricBounds[3] - myTextFrame.geometricBounds[1]) - myGutterWidth * (myColumnCount-1) ) / myColumnCount ;
				for (var i=0; i< myColumnCount-1; i++)
				{
						//alert("колонка "+i);
						x1 = myTextFrame.geometricBounds[1] + myTFColumnWidth * (1+i) +myGutterWidth * i;
						x2 = x1 + myGutterWidth;
						xc = (x1+x2)/2;
						// Цикл по объектам страницы
						for( var j=0; j < myPageItems.length; j++ ) {
							if( myPageItems[j] == myTextFrame) continue; // исключаем из рассмотрения сам текущий текстовый фрейм
							if( myPageItems[j].geometricBounds[1] > x2) continue;
							if( myPageItems[j].geometricBounds[3] < x1) continue;
							if( myPageItems[j].geometricBounds[2] < myTextFrame.geometricBounds[0] ) continue;
							if( myPageItems[j].geometricBounds[0] > myTextFrame.geometricBounds[2] ) continue;
							myNewObj.push(myPageItems[j]); 
						} // конец цикла по объектам страницы
						//alert(myNewObj.length);
						myLineDraw ( myPage, myTextFrame.geometricBounds[0], myTextFrame.geometricBounds[2], xc, myNewObj, myObjectStyleName, myDelta);
						myNewObj.length = 0;
				}// конец цикла по колонkам				
				
	}// for по текстовым фреймам всей Story

} //function()


function myLineDraw ( myPage, myY1, myY2, myX, myObj, myObjectStyleName, myD)
{
		if(!myObj.length) { // нету объектов, пересекающих колонку
		var myLineGBounds = [myY1, myX, myY2, myX];
		  //alert("рисуем линию")
		  var myNewGrLine = myPage.graphicLines.add();		  
			with (myNewGrLine)
				{
					geometricBounds = myLineGBounds;
				}
			myNewGrLine.appliedObjectStyle = app.activeDocument.objectStyles.item(myObjectStyleName);
		} // if
	else {
		//alert("рисуем неск линий");
		var mySortObj = mySort(myObj);
		//for(var i=0; i<mySortObj.length; i++) alert(mySortObj[i].geometricBounds[0]); // проверка сортировки
		//alert("количество отсортированных объектов"+mySortObj.length);
		var myGrLineBoundsY1 = new Array(mySortObj.length+1);
		var myGrLineBoundsY2 = new Array(mySortObj.length+1);
		myGrLineBoundsY1[0] = myY1;
		for(var i=0; i< mySortObj.length; i++)
			{
				myGrLineBoundsY1[i+1] = mySortObj[i].geometricBounds[2] + myD;
			}
		myGrLineBoundsY2[myGrLineBoundsY2.length-1] = myY2;
		for(var i= 0 ; i<mySortObj.length; i++)
			{
				myGrLineBoundsY2[i] = mySortObj[i].geometricBounds[0] - myD;
			}
		if( (myGrLineBoundsY2[0] - myY1) <=0) 
			{
			myGrLineBoundsY1.shift();
			myGrLineBoundsY2.shift();
			}
		if(myY2 - myGrLineBoundsY1[myGrLineBoundsY2.length-1] <=0) 
			{
			myGrLineBoundsY1.pop();
			myGrLineBoundsY2.pop();
			}
		for(var i=0; i < myGrLineBoundsY1.length; i++) 
			{
				var myBounds = [myGrLineBoundsY1[i], myX, myGrLineBoundsY2[i], myX];
				if(myGrLineBoundsY2[i] - myGrLineBoundsY1[i] >0) 
					{
					var myNewGrLine = myPage.graphicLines.add();
					with (myNewGrLine) {geometricBounds = myBounds;}
					try {
					myNewGrLine.appliedObjectStyle = app.activeDocument.objectStyles.item(myObjectStyleName);}
					catch(e){};
					}
			}//for
		
		
		}// else
} // function

function mySort(myObj)
{
	var indicator;
	do {
			indicator=false;
			for(var i=0; i<myObj.length-1; i++) {
				if(myObj[i].geometricBounds[0]  > myObj[i+1].geometricBounds[0]) { 
					mySwap(myObj, i); 
					indicator=true;
				}
				
			} // for		
	} while (indicator);
	return myObj;
} // function
 
function mySwap(myObj, i) 
{
	var myBuffer = myObj[i];
	myObj[i] = myObj[i+1];
	myObj[i+1] = myBuffer;
}